/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4 c-style: "K&R" -*- */

/*-----------------------------------------------------------------------------

   libgpiv - library for Particle Image Velocimetry

   Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007, 2008 Gerber van der Graaf

   This file is part of libgpiv.

   Libgpiv is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

-----------------------------------------------------------------------------*/

/*!
\file                    gpiv-image.h
\brief                   module for GpivImage: image data and header

*/


#ifndef __LIBGPIV_IMAGE_H__
#define __LIBGPIV_IMAGE_H__


#include <gpiv/gpiv-imagepar.h>


#define GPIV_EXT_PNG_IMAGE     ".png"          /**< Extension of png (Portable Network Graphics) formatted image file name*/
#define GPIV_EXT_PNG_IMAGE_UPCASE ".PNG"       /**< Uppercase extension of png */
#define GPIV_EXT_HEADER        ".h"            /**< Extension of image header file name */
#define GPIV_EXT_RAW_IMAGE     ".r"	       /**< Extension of raw image file name */
#define GPIV_EXT_PGM_IMAGE     ".pgm"          /**< Extension of raw portable graymap (pgm) image file name */
#define GPIV_EXT_PGM_IMAGE_UPCASE ".PGM"       /**< Uppercase extension of pgm */
#define GPIV_EXT_GPIV          ".h5"	       /**< Extension of gpiv file name (HDF 5 format) */
#define GPIV_EXT_GPIV_UPCASE   ".H5"           /**< Uppercase extension of gpiv file name (HDF 5 format) */
#define GPIV_EXT_PIV           ".piv"	       /**< Extension of piv file name (ASCII format) */
#define GPIV_EXT_DAVIS         ".img"          /**< DaVis image format */
#define GPIV_EXT_DAVIS_UPCASE  ".IMG"          /**< Uppercase DaVis image format */
#define GPIV_DAVIS_IMG_DEPTH   12              /**< Depth of mages generated by LaVision's Davis (general: PCO cameras) */


/* typedef struct __GpivImage GpivImage; */

/*!
 * \brief Piv image header and data
 *
 * Two image frames have been included for double-framed PIV image pairs.
 */
typedef struct __GpivImage {
    GpivImagePar *header;              /**< Image header */ 
    guint16 **frame1;                  /**< First image of a double-frame image pair */
    guint16 **frame2;                  /**< Second image of a double-frame image pair */
} GpivImage;



/**
 *      Reads image from fp. Image will have to be png formatted.
 *
 *      @param[in] fp           file pointer. If NULL, stdin will be used.
 *      @return                 pointer to GpivImage
 */
GpivImage *
gpiv_read_image				(FILE			*fp
                                         );



/**
 *      Reads image from file fname.
 *
 *      @param[in] fname        complete filename. This is used to
 *                              pick the image format loader. Eventually 
 *                              checking the format signature is done in the
 *                              loader itself
 *      @return                 GpivImage or NULL on failure
 */
GpivImage *
gpiv_fread_image			(const gchar		*fname
                                         );

/**
 *      Reads png formatted image.
 *
 *      @param[in] fp           file pointer
 *      @return                 pointer to GpivImage
 */
GpivImage *
gpiv_read_png_image			(FILE			*fp
                                         );


/**
 *      Writes image data and header to png formatted image. 
 *      Optionally frees allocated memory.
 *
 *      @param[in] fname        output file name.
 *      @param[in] gpiv_image   image header and data
 *      @param[in] free         boolean whether to free memory of image arra
 *      @return                 NULL on success or error message on failure
 */
gchar *
gpiv_fwrite_png_image                    (const gchar           *fname,
                                          GpivImage             *gpiv_image,
                                          const gboolean	free
                                          );

/**
 *      Writes image data and header to png formatted image. 
 *      Optionally frees allocated memory.
 *
 *      @param[in] fp           output file.
 *      @param[in] gpiv_image   image header and data
 *      @param[in] free         boolean whether to free memory of image arrays
 *      @return                 NULL on success or error message on failure
 */
gchar *
gpiv_write_png_image			(FILE			*fp,
                                         GpivImage		*gpiv_image,
                                         const gboolean		free
                                         );


/**
 *      Reads image data to a hdf5 data file.
 *
 *      @param[in] fname        pointer to complete filename
 *      @return                 GpivImage on success or NULL on failure
 */
GpivImage *
gpiv_fread_hdf5_image			(const gchar		*fname
                                         );


/**
 *      Writes image data to file in hdf version 5 format.
 *
 *      @param[in] fname        pointer to complete filename
 *      @param[in] image        image frkames and header
 *      @param[in] free         boolean whether to free memory of image arrays
 *      @return                 NULL on success or error message on failure
 */
gchar *
gpiv_fwrite_hdf5_image			(const gchar		*fname, 
                                         GpivImage		*image,
                                         const gboolean		free
                                         );

/**
 *      Reads Davis formatted image, with ext .IMG from file.
 *
 *      @param[in] fp           pointer to input file
 *      @return                 GpivImage on success or NULL on failure
 */
GpivImage *
gpiv_read_davis_image			(FILE			*fp
                                         );

/**
 *      Discouraged. 
 *      Reads an image from raw binary file.
 *      Expects the arrray (s) have not been allocated yet.
 *      Eventually, required header info will be read from (system) resources
 *      gpiv.conf or $HOME/.gpivrc.
 *
 *      @param[in] fp           input file. If NULL, stdin will be used
 *      @return                 GpivImage on success or NULL on failure
 */
GpivImage *
gpiv_read_raw_image			(FILE			*fp
					);


/**
 *      Discouraged. 
 *      Reads an image from raw binary file.
 *      Expects the arrray(s) have not been allocated yet.
 *      Reads image data from file.r, header from file.h
 *      Eventually, required header info will be read from (system) resources
 *      gpiv.conf or $HOME/.gpivrc.
 *
 *      @param[in] fname        complete image filename (ending on .r) 
 *      @return                 GpivImage on success or NULL on failure
 */
GpivImage *
gpiv_fread_raw_image			(const gchar		*fname
                                         );

/**
 *      Discouraged. 
 *      Writes raw binary image frames to fp.
 *
 *      @param[in] fp           output file. If NULL, stdout will be used
 *      @param[in] gpiv_image   image frames and header
 *      @return                 NULL on success or error message on failure
 */
gchar *
gpiv_write_raw_image			(FILE			*fp,
                                         GpivImage		*gpiv_image
                                         );


/**
 *      Discouraged. 
 *      Writes raw binary image data to file.r and header to file.h.
 *
 *      @param[in] fname        complete image filename (ending on .r)
 *      @param[in] gpiv_image   image frames and header info
 *      @return                 NULL on success or error message on failure
 */
gchar *
gpiv_fwrite_raw_image			(const gchar		*fname,
                                         GpivImage		*gpiv_image
                                         );

/*
 * From gpiv_img_utils.h
 */
/**
 *     Allocates memory for GpivImage frames
 *
 *     @param[in] image_par    image parameters
 *     @return                 GpivImage
 */
GpivImage *
gpiv_alloc_img                          (const GpivImagePar     *image_par
                                         );


/**
 *     Checks if image frames have been allocated
 *     TODO BUGFIX: check on correct size
 *
 *     @param[in] image        image to be checked if allocated
 *     @return                 NULL on success or error message on failure
 */
gchar *     
gpiv_check_alloc_img 			(const GpivImage 	*image
                                         );



/**
 *     Frees memory of gpiv_image
 *
 *     @param[in] gpiv_image   image structure containging data frames and parameters
 *     @return                 void
 */
void 
gpiv_free_img                           (GpivImage              *gpiv_image
                                         );


/**
 *      Duplicates image. The returned image will have to be freed with 
 *      gpiv_free_img when no longer needed.
 *
 *     @param[in] image        source image
 *     @return                 GpivImage containing the copied header and 
 *                             image data from the source image 
 *                             or NULL on failure.
 */
GpivImage *
gpiv_cp_img                             (const GpivImage        *image
                                         );


/**
 *      Copies contents of img_src to img_dest. Image_src and image_dest
 *      will have to be allocated with gpiv_alloc_img before and will have to
 *      be freed with gpiv_free_img when no longer needed.
 *
 *     @param[in] image_src     source image to be copied
 *     @param[out] image_dest   destination image, copy of source
 *     @return                  NULL on success or error message on failure
 */
gchar *
gpiv_cp_img_data                        (const GpivImage        *image_src, 
                                         GpivImage              *image_dest
                                         );
#ifdef ENABLE_MPI

/**
 *     Broadcasts image for MPI
 *
 *     @param[in] image         image to be broadcasted
 *     @param[in] alloc_frame   boolean if frame buffer(s) will have to be allocated
 *				for non-root (rank != 0) nodes
 *     @return                  void
 */
void
gpiv_img_mpi_bcast_image                (GpivImage              *image,
                                         const gboolean         alloc_frame
                                         );

/**
 *     Broadcasts image frame data fro MPI
 *
 *     @param[in] image         image to be broadcasted
 *     @return                  void
 */
void
gpiv_img_mpi_bcast_imgframe             (GpivImage              *image
                                         );

#endif /* __LIBGPIV_IMAGE_H__ */
#endif /* __LIBGPIV_IMAGE_H__ */
